/***************************************************************************
 *   Copyright (C) 2004 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

#include "coh.h"
#include <sys/time.h>


// ݲΤޤʤ
#ifdef HAVE_GETTEXT
  #include <libintl.h>
  #define _(String) dgettext(GETTEXT_PACKAGE,String)
  #define N_(String) (String)
#else
  #define _(String) (String)
  #define N_(String) (String)
  #define bindtextdomain(Package,Directory)
  #define textdomain(domain)
  #define bind_textdomain_codeset(domain,codeset)
#endif

#ifndef PACKAGE_STRING
 #define PACKAGE_STRING "honoka-coh"
#endif

HonokaPluginRegister(CoH);
HonokaPluginSetup(CoH);

HonokaSetupCorePage *CoH::setup()
{
    HonokaSetupPage *page = new HonokaSetupPage(_("the Counterattack of Honoka"),"","");
    return page;
};

CoH::CoH(ConfigPointer cfg) : PreEditor(cfg)
{
    bindtextdomain (GETTEXT_PACKAGE, HONOKA_COH_LOCALEDIR);
    bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");

    frame = 0;
    started = false;
    adv_text = utf8_mbstowcs(_("Her name is "));
    rep_text = utf8_mbstowcs(_("Ho,"));
    fin_text = utf8_mbstowcs(_("Honoka!"));
}


CoH::~CoH()
{
}

bool CoH::keyEventHook(const KeyEvent &key)
{
    if (!key.is_key_press()) return true;
    if (started) result();
    else {
        clearTimerEvents();
        start();
        frame = 0;
    }
    return true;
}

String CoH::getModeName()
{
    return _("[CoH]");
}

String CoH::getName()
{
    return "CoH";
}

String CoH::getPropertyName()
{
    return _("the Counterattack of Honoka");
}

void CoH::selected()
{
    started = false;
    clearTimerEvents();
}

void CoH::unSelected()
{
    started = false;
    clearTimerEvents();
}

void CoH::timerEvent(int id)
{
    frame ++;
    if (frame < full_text.length()) {
        text = full_text.substr(0,frame);
        setPos(text.length());
        clearTimerEvents();
        appendDelayEvent(1);
    } else {
        text = full_text;
        setPos(text.length());
        result();
    }
}

WideString CoH::getText(bool hosei)
{
    if (hosei) return WideString();
    return text;
}



/*!
    \fn CoH::start()
 */
void CoH::start()
{
    clearTimerEvents();
    started = true;
    struct timeval tv;
    gettimeofday(&tv, NULL);
    full_text = adv_text;
    for(int c = (tv.tv_usec % 8) + 1;c > 0;c --) full_text += rep_text;
    full_text += fin_text;
    appendDelayEvent(1);

}


/*!
    \fn CoH::result()
 */
void CoH::result()
{
    started = false;
    clearTimerEvents();
    int s = frame - (full_text.length() - fin_text.length());
    text = full_text;
    if (s < 0) text += utf8_mbstowcs(String(_("[too first!]")));
    else if (s == 0) text += utf8_mbstowcs(String(_("[you are god ?]")));
    else if (s == 1) text += utf8_mbstowcs(String(_("[marvelous!!]")));
    else if (s == 2) text += utf8_mbstowcs(String(_("[coooool!!]")));
    else if (s == 3) text += utf8_mbstowcs(String(_("[good!]")));
    else if (s == 4) text += utf8_mbstowcs(String(_("[yes!]")));
    else if (s == 5) text += utf8_mbstowcs(String(_("[ok]")));
    else text += utf8_mbstowcs(String(_("[too late...]")));
}
